//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation
import JSONUtilities

extension API.ApiAlerte {

    /** Ajoute un événement spécifique à une alerte voisinage */
    public enum PostApiAlerteAjouterEvenement {

        public static let service = APIService<Response>(id: "postApiAlerteAjouterEvenement", tag: "Api Alerte", method: "POST", path: "/apiAlerte/ajouterEvenement", hasBody: false)

        /** Ajoute un événement spécifique à une alerte voisinage */
        public enum TypeEvenement: String {
            case actsoupcon = "ACT_SOUPCON"
            case actdangeravere = "ACT_DANGER_AVERE"
            case actconfirme = "ACT_CONFIRME"
            case actannule = "ACT_ANNULE"
            case obsdanger = "OBS_DANGER"
            case obscallok = "OBS_CALLOK"
            case obsras = "OBS_RAS"
            case obspolice = "OBS_POLICE"
            case obsokmerci = "OBS_OKMERCI"
            case obsverif = "OBS_VERIF"

            public static let cases: [TypeEvenement] = [
              .actsoupcon,
              .actdangeravere,
              .actconfirme,
              .actannule,
              .obsdanger,
              .obscallok,
              .obsras,
              .obspolice,
              .obsokmerci,
              .obsverif,
            ]
        }

        public final class Request: APIRequest<Response> {

            public struct Options {

                public var idAlerte: String

                public var typeEvenement: TypeEvenement

                public var nomFoyerEmetteur: String

                public init(idAlerte: String, typeEvenement: TypeEvenement, nomFoyerEmetteur: String) {
                    self.idAlerte = idAlerte
                    self.typeEvenement = typeEvenement
                    self.nomFoyerEmetteur = nomFoyerEmetteur
                }
            }

            public var options: Options

            public init(options: Options) {
                self.options = options
                super.init(service: PostApiAlerteAjouterEvenement.service)
            }

            /// convenience initialiser so an Option doesn't have to be created
            public convenience init(idAlerte: String, typeEvenement: TypeEvenement, nomFoyerEmetteur: String) {
                let options = Options(idAlerte: idAlerte, typeEvenement: typeEvenement, nomFoyerEmetteur: nomFoyerEmetteur)
                self.init(options: options)
            }

            public override var parameters: [String: Any] {
                var params: JSONDictionary = [:]
                params["idAlerte"] = options.idAlerte
                params["typeEvenement"] = options.typeEvenement.encode()
                params["nomFoyerEmetteur"] = options.nomFoyerEmetteur
                return params
            }
        }

        public enum Response: APIResponseValue, CustomStringConvertible, CustomDebugStringConvertible {
            public typealias SuccessType = Void

            /** Succes */
            case status200

            /** Erreur */
            case status400

            /** Erreur */
            case status500

            public var success: Void? {
                switch self {
                case .status200: return ()
                default: return nil
                }
            }

            public var response: Any {
                switch self {
                default: return ()
                }
            }

            public var statusCode: Int {
                switch self {
                case .status200: return 200
                case .status400: return 400
                case .status500: return 500
                }
            }

            public var successful: Bool {
                switch self {
                case .status200: return true
                case .status400: return false
                case .status500: return false
                }
            }

            public init(statusCode: Int, data: Data) throws {
                switch statusCode {
                case 200: self = .status200
                case 400: self = .status400
                case 500: self = .status500
                default: throw APIError.unexpectedStatusCode(statusCode: statusCode, data: data)
                }
            }

            public var description: String {
                return "\(statusCode) \(successful ? "success" : "failure")"
            }

            public var debugDescription: String {
                var string = description
                let responseString = "\(response)"
                if responseString != "()" {
                    string += "\n\(responseString)"
                }
                return string
            }
        }
    }
}
